// {{{
#include <cstdio>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <cassert>
#define SIZE(x) ((int) (x).size())
#define REP(i, n) for (int i = 0; i < (int) (n); ++i)
#define FOR(i, a, b) for (int i = (int) (a); i <= (int) (b); ++i)
#define FORD(i, a, b) for (int i = (int) (a); i >= (int) (b); --i)
#define FORE(i, c) for (__typeof((c).begin()) i = (c).begin(); i != (c).end(); ++i)
#define DEBUG(x) { cerr << #x << ": " << (x) << endl; }
using namespace std;

typedef long long LL;
// }}}

typedef pair<int, int> PI;
#define INF 1023456789

int main() {
	int n, m, w, k;
	while (scanf("%d%d%d%d", &n, &m, &w, &k), n) {
		vector<vector<PI> > G(n);
		while (m--) {
			int a, b, c;
			scanf("%d%d%d", &a, &b, &c);
			--a, --b;
			G[a].push_back(PI(b, c));
			G[b].push_back(PI(a, c));
		}
		vector<vector<int> > D(k + 1, vector<int>(n, INF));
		vector<int> A(w);
		REP(i, w) {
			scanf("%d", &A[i]);
			--A[i];
			D[0][A[i]] = i;
		}

		FOR(d, 1, k) REP(i, n) FORE(j, G[i])
			if (d >= j->second)
				D[d][i] = min(D[d][i], D[d - j->second][j->first]);

		vector<int> T(n, INF);
		FOR(d, 0, k - 1) REP(i, n)
			T[i] = min(T[i], D[d][i]);

		vector<int> Q(w, 0);
		REP(i, n)
			if (T[i] != INF)
				Q[T[i]]++;

		int res = n;
		REP(i, w) {
			res -= Q[i];
			printf("%d\n", res);
		}
		printf("\n");
	}
}
