// {{{
#include <cstdio>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <cassert>
#define SIZE(x) ((int) (x).size())
#define REP(i, n) for (int i = 0; i < (int) (n); ++i)
#define FOR(i, a, b) for (int i = (int) (a); i <= (int) (b); ++i)
#define FORD(i, a, b) for (int i = (int) (a); i >= (int) (b); --i)
#define FORE(i, c) for (__typeof((c).begin()) i = (c).begin(); i != (c).end(); ++i)
#define DEBUG(x) { cerr << #x << ": " << (x) << endl; }
using namespace std;
#define eps 1e-10

typedef long long LL;
typedef long double LD;
// }}}

LD x,y,r;
int N;

int main() {
	while(1){
		scanf("%Lf %Lf %d %Lf",&x,&y,&N,&r);
		if (N==0) break;
		r = r/1200.0;
		if (x*r>y+eps) {
			printf("NO\n");
			continue;
		}
		if (r<eps) {
			if (x>y*12.0*N+eps) printf("NO\n");
			else printf("YES\n");
			continue;
		}
		r+=1.0;
		LD pn = pow(r,LD(12*N));
//		printf("%Lf %Lf %Lf %Lf\n",x,y,pn,r);
		if (x*pn*(r-1.0)-y*(pn-1.0)>eps) printf("NO\n");
		else printf("YES\n");
	}
}
