// {{{
#include <cstdio>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <cassert>
//#define SIZE(x) ((int) (x).size())
#define REP(i, n) for (int i = 0; i < (int) (n); ++i)
#define FOR(i, a, b) for (int i = (int) (a); i <= (int) (b); ++i)
#define FORD(i, a, b) for (int i = (int) (a); i >= (int) (b); --i)
#define FORE(i, c) for (__typeof((c).begin()) i = (c).begin(); i != (c).end(); ++i)
#define DEBUG(x) { cerr << #x << ": " << (x) << endl; }
using namespace std;
#define eps 1e-8

typedef long long LL;
// }}}

#define SIZ 51

string str;
int H,M;
char line[100][100];
char cele[100][100];
int flags[8];

void draw(int L,double D){
	REP(i,SIZ) REP(j,SIZ) line[i][j] = ' ';
	double Q = D;
	if (Q>M_PI) {
		Q-=M_PI;
		flag1

	}

	Q = fabs(Q-M_PI*0.5);
	Q = fabs(Q-M_PI*0.25);
	double tag = tan(Q);
	REP(i,L){
		double x = (double(i)+0.5)*tag+0.5;
		if (x*x+(i+0.5)*(i+0.5)<L*L+eps) line[25-i][25+int(x+0.5)] = 'a';
	}
	REP(i,SIZ) REP(j,SIZ){
		if (line[i][j]=='a'){
			if (line[i-1][j]=='a' && line[i+1][j]=='a') { cele[i][j]='-'; continue; }
			if (line[i][j-1]=='a' && line[i][j+1]=='a') { cele[i][j]='|'; continue; }
			if (line[i-1][j+1]=='a' && line[i+1][j-1]=='a') { cele[i][j]='\\'; continue; }
			if (line[i-1][j-1]=='a' && line[i+1][j+1]=='a') { cele[i][j]='/'; continue; }
			cele[i][j] = 'o';
		}
	}
}

int main() {
	while(1){
		cin >> str;
		if (str[0]=='E') break;
		sscanf(str.c_str(),"%d:%d",&H,&M);
		REP(i,SIZ) REP(j,SIZ) cele[i][j] = ' ';
		REP(i,SIZ) cele[i][SIZ] = 0;		
		REP(i,SIZ) {
			cele[0][i] = cele[SIZ-1][i] = cele[i][0] = cele[i][SIZ-1] = (i%10==0)?'@':'X';
		}
		cele[2][24] = '1';
		cele[2][26] = '2';
		cele[49][25] = '2';
		cele[25][2] = '2';
		cele[25][49] = '2';
		
		draw(15,(2*M_PI/12)*(double(H)+double(M)/60.0));
		draw(21,(2*M_PI/60.0)*double(M));

		REP(i,SIZ){
			printf("%s\n",cele[i]);
		}
		printf("\n");
	}
}
